@echo off
setlocal enableextensions enabledelayedexpansion
call :getargc argc %*
if %argc% GTR 9 goto :too_many_args
endlocal

call :cmdline %CMDCMDLINE%
IF /I "%MYSWITCH%" == "/C" start /B  "RAP Agent" javaw -Xmx512m -jar robot-rap-agent.jar %1 %2 %3 %4 %5 %6 %7 %8 %9
IF /I NOT "%MYSWITCH%" == "/C" java -Xmx512m -jar robot-rap-agent.jar %1 %2 %3 %4 %5 %6 %7 %8 %9

IF %ERRORLEVEL% EQU 9009 goto :no_java
IF /I "%MYSWITCH%" == "/C" exit %ERRORLEVEL%
IF /I NOT "%MYSWITCH%" == "/C" exit /B %ERRORLEVEL%

:too_many_args
echo(

echo The command contains %argc% arguments while the batch file 
echo can handle 9 ones at a maximum. Please use the direct Java 
echo command as is described in the CLI specification at:
echo(
echo   http://www.t-plan.com/robot/docs/latest/cli/clioptions.html
echo(
echo Press any key to exit...
pause >nul
goto :eof

:no_java
echo(

echo Please make sure that you have Java 1.8 or higher installed
echo and configured.
echo(
echo Press any key to exit...
pause >nul
goto :eof

:getargc
    set getargc_v0=%1
    set /a "%getargc_v0% = 0"
:getargc_l0
    if not x%2x==xx (
        shift
        set /a "%getargc_v0% = %getargc_v0% + 1"
        goto :getargc_l0
    )
    set getargc_v0=
    goto :eof

:cmdline
SET MYSWITCH=%2

